﻿-- Loot Prio Mouseover

Version="202008192311"
local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:RegisterEvent("PLAYER_LOGOUT")
--self.eventFrame:RegisterEvent("CHAT_MSG_ADDON")
--PLAYER_LOGIN

function f:OnEvent(event, arg1, ...)
  if event == "ADDON_LOADED" and arg1 == "LostRabbitsPrio" then
    if LostRabbitsPrio == nil then
      LostRabbitsPrio = defaultLostRabbitsPrio
    end
    if LostRabbitsPrio["Pupdated"] == nil then
      LostRabbitsPrio["Pupdated"]=0
    end
  elseif (event == "CHAT_MSG_ADDON") then
    local msg, distribution, sender = ...;
    if (arg1 == "LRP" and distribution == "GUILD") then
      receiveDataFromGuild(msg)
    end
  elseif event == "PLAYER_ENTERING_WORLD" then
    C_ChatInfo.RegisterAddonMessagePrefix("LRP")
    local guildname = GetGuildInfo("player")
    if guildname=="Lost Rabbits" then
      LostRabbitsPrio["P" .. UnitName("player")]=Version .. "-" .. LostRabbitsPrio["Pupdated"];
    end
    sendDataToGuild()
    OwnPrioText=createOwnPrio(UnitName("player"))    
  end
end

local function SetGameToolTipPrio(tt)
  local container = GetMouseFocus()
  local itemLink = select(2, tt:GetItem())
  local _, _, Color, Ltype, Id, Enchant, Gem1, Gem2, Gem3, Gem4, Suffix, Unique, LinkLvl, Name = string.find(itemLink,"|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
  if itemLink then
    iteminfo = select(1, GetItemInfo(itemLink))
    if LostRabbitsPrio[Id] ~= nil then
      tt:AddDoubleLine(LostRabbitsPrio[Id])
    end
  end
end

GameTooltip:HookScript("OnTooltipSetItem", SetGameToolTipPrio)
ItemRefTooltip:HookScript("OnTooltipSetItem", SetGameToolTipPrio)
f:RegisterEvent("CHAT_MSG_ADDON")
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:RegisterEvent("MODIFIER_STATE_CHANGED")
f:SetScript("OnEvent", f.OnEvent)

function displayImport()
  LRPFrame:Show();
  LRPFrameScroll:Show()
  LRPFrameScrollText:Show()
  LRPFrameScrollText:SetText("")
  LRPFrameScrollText:HighlightText()
  LRPFrameScrollText:SetScript("OnEscapePressed", function(self) self:Hide() end)
  LRPFrameButton1:SetScript("OnClick", function(self) importData(LRPFrameScrollText:GetText()); end);
  LRPFrameButton2:SetScript("OnClick", function(self) LRPFrame:Hide(); end);
  LRPFrameButton3:SetScript("OnClick", function(self) resetList(); end);
end

function displayExport(msg)
  local tmp = createExportRawData(msg)
  LRPFrame:Show();
  LRPFrameScroll:Show()
  LRPFrameScrollText:Show()
  LRPFrameScrollText:SetText(tmp)
  LRPFrameScrollText:HighlightText()
  LRPFrameScrollText:SetScript("OnEscapePressed", function(self) self:Hide() end)
  LRPFrameButton1:Show()
  LRPFrameButton2:Show()
  LRPFrameButton1:SetScript("OnClick", function(self) importData(LRPFrameScrollText:GetText()); end);
  LRPFrameButton2:SetScript("OnClick", function(self) LRPFrame:Hide(); end);
  LRPFrameButton3:SetScript("OnClick", function(self) resetList(); end);
end

function printOwnPrio(arg1)
  if arg1~=nil then
    print("Prio für " .. arg1 .. ": " .. createOwnPrio(arg1))
  else
    print("Prio für " .. UnitName("player") .. ": " .. createOwnPrio(UnitName("player")))
  end
end

commandTable = {
  ["import"] = function()
    displayImport()
  end,
  ["export"] = function(arg1)
    displayExport(arg1)
  end,
  ["own"] = function(arg1)
    printOwnPrio(arg1)
  end,
  ["send"] = function(arg1)
    sendDataToGuild(arg1)
  end,
  ["reset"] = function()
    resetList()
  end,
}

SLASH_LOSTRABBITSPRIO1 = "/lostrabbitsprio"
SLASH_LOSTRABBITSPRIO2 = "/lrp"
SlashCmdList["LOSTRABBITSPRIO"] = function(msg)
  commandExecute(msg) 
end 

function resetList()
  LostRabbitsPrio = {}
  LostRabbitsPrio = defaultLostRabbitsPrio
  LostRabbitsPrio["Pupdated"]=GetServerTime();
end

function commandExecute(text)
  local command, parameters = strsplit(" ", text, 2)
  local entry = commandTable[command:lower()]
  local which = type(entry)
  if which == "function" then
    entry(parameters)
  elseif which == "table" then
    commandExecute(parameters, entry)
  end
end

function createOwnPrio(playername)
local tmp=""
local tablekey=""
local counter=0
  tmpOwnPrio = {}
  PlayerPrioText = ""
  for key, zeile in pairs(LostRabbitsPrio) do
    if string.find(zeile,playername) ~= nil then
      pos = string.find(zeile,":[^:]*" .. playername)
      counter=string.sub(zeile,pos-1,pos-1)
      item = Item:CreateFromItemID(tonumber(key))   
      tmpOwnPrio[counter]=key    
    end
  end
  for key, zeile in orderedPairs(tmpOwnPrio) do
    item = Item:CreateFromItemID(tonumber(zeile))   
    item:ContinueOnItemLoad(function()                        
      local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType,
            itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(tonumber(zeile));
      local r, g, b, hex = GetItemQualityColor(itemRarity)
      tmp="|c" .. hex .. "|Hitem:" .. zeile .. ":::::::::::::::|h[" .. itemName .. "]|h|r"
      PlayerPrioText=PlayerPrioText .. key .. ":" .. tmp .. ", "
    end);
  end
  return PlayerPrioText
end

function receiveDataFromGuild(msg)
  if LostRabbitsPrio["Pupdated"] == nil then
    LostRabbitsPrio["Pupdated"]=0
  end
  if tonumber(LostRabbitsPrio["Pupdated"])<=tonumber(string.sub(msg,1,10)) then
    LostRabbitsPrio["Pupdated"]=tonumber(string.sub(msg,1,10))
    importData_partly(string.sub(msg,11))
    OwnPrioText=createOwnPrio(UnitName("player"))
  end
  local guildname = GetGuildInfo("player")
  if guildname=="Lost Rabbits" then
    LostRabbitsPrio["P" .. UnitName("player")]=Version .. "-" .. LostRabbitsPrio["Pupdated"];
  end
end

function sendDataToGuild(arg1)
  if arg1=="push" then
    LostRabbitsPrio["Pupdated"]=GetServerTime();
  end 
  local tmp = createExportRawData("P")
  while string.len(tmp)>0
  do
    local start = string.find(tmp,"\n")
    while start~=nil and start<250
    do
      start2=start
      start = string.find(tmp,"\n",start2+1)
    end
    if start ~= nil then
      C_ChatInfo.SendAddonMessage("LRP", LostRabbitsPrio["Pupdated"] .. string.sub(tmp,1,start2-1), "GUILD")   
    else
      C_ChatInfo.SendAddonMessage("LRP", LostRabbitsPrio["Pupdated"] .. string.sub(tmp,1), "GUILD")
      break
    end 
    tmp=string.sub(tmp,start2+1)
  end
end

function createExportRawData(msg)
local tmp=""
  for key, zeile in pairs(LostRabbitsPrio) do
    if string.sub(key,1,1)~="P" or msg=="P" then
      tmp=tmp .. key .. "~"
      for i=1,5 do
        if string.find(zeile,i .. ":[^:]*[\n]") ~= nil then
          local pos, ende = string.find(zeile,i .. ":[^:]*[\n]")
          if ende == nil then
            tmp=tmp .. string.sub(zeile, pos+2) .. ","
          else
            tmp=tmp .. string.sub(zeile, pos+2, ende-1) .. ","
          end
        end
        tmp=tmp .. "~"
      end
      if string.find(zeile,"Info:[^:]*[\n]") ~= nil then
        pos=string.find(zeile,"Info:[^:]*[\n]")
        tmp=tmp .. string.sub(zeile, pos+5, -4) 
      end
      if string.sub(key,1,1)=="P" then
	tmp=tmp .. zeile
      end 
      tmp=tmp .. "####\n"
    end
  end
  return tmp
end 

function importData(arg1)
  LostRabbitsPrio["Pupdated"]=GetServerTime();
  importData_partly(arg1)
end

function importData_partly(arg1)
local tmp=""
local tablekey=""
local counter=0
  if string.sub(arg1,-1,-1) ~= "\n" then
    arg1 = arg1 .. "\n"
  end
  local items = {strsplit("####\n", arg1)} 
  for key, zeile in pairs(items) do
    local item = {strsplit("~", zeile)}
    for key2, attribute in pairs(item) do
      if tablekey == "" then
        tablekey=attribute
      elseif attribute ~= nil and attribute ~= "" then 
	if tmp ~= "" then
          tmp = tmp .. "\n"
        end
        if counter == 6 then 
          if string.sub(attribute,1,5)=="Info:" then
            attribute=string.sub(attribute,6)
          end
          tmp=tmp .. "Info:" .. attribute
        else
          if string.sub(attribute,-1,-1)=="," then
            attribute=string.sub(attribute,1,string.len(attribute)-1)
          end
          tmp=tmp .. counter .. ":" .. attribute
        end
      end
      counter = counter + 1
    end 
    if string.sub(tablekey,1,1)=="P" and tablekey ~= "Pupdated" then 
      LostRabbitsPrio[tablekey]=tmp
    elseif tablekey ~= "" and tablekey ~= "Pupdated" then 
      LostRabbitsPrio[tablekey]="\n|cff6495EDPrio Lost Rabbits Blau: \n" .. tmp .. "\n|r"
    end 
    tmp=""
    tablekey=""
    counter=0
  end 
  OwnPrioText=createOwnPrio(UnitName("player"))
end

function __genOrderedIndex( t )
    local orderedIndex = {}
    for key in pairs(t) do
        table.insert( orderedIndex, key )
    end
    table.sort( orderedIndex )
    return orderedIndex
end

function orderedNext(t, state)
    -- Equivalent of the next function, but returns the keys in the alphabetic
    -- order. We use a temporary ordered key table that is stored in the
    -- table being iterated.

    local key = nil
    --print("orderedNext: state = "..tostring(state) )
    if state == nil then
        -- the first time, generate the index
        t.__orderedIndex = __genOrderedIndex( t )
        key = t.__orderedIndex[1]
    else
        -- fetch the next value
        for i = 1,table.getn(t.__orderedIndex) do
            if t.__orderedIndex[i] == state then
                key = t.__orderedIndex[i+1]
            end
        end
    end

    if key then
        return key, t[key]
    end

    -- no more value to return, cleanup
    t.__orderedIndex = nil
    return
end

function orderedPairs(t)
    -- Equivalent of the pairs() function on tables. Allows to iterate
    -- in order
    return orderedNext, t, nil
end